--- app_record.c	2011-09-19 11:47:47.000000000 +1000
+++ app_record.c	2011-09-19 11:46:41.000000000 +1000
@@ -157,7 +157,6 @@
 	int gotsilence = 0;		/* did we timeout for silence? */
 	int maxduration = 0;		/* max duration of recording in milliseconds */
 	int gottimeout = 0;		/* did we timeout for maxduration exceeded? */
-	int truncate = 1;		/* truncate on complete silence recording */
 	int terminator = '#';
 	int rfmt = 0;
 	int ioflags;
@@ -220,9 +219,6 @@
 	if (ast_test_flag(&flags, OPTION_IGNORE_TERMINATE))
 		terminator = '\0';
 
-	if (ast_test_flag(&flags, OPTION_NO_TRUNCATE))
-		truncate = 0;
-
 	/* done parsing */
 
 	/* these are to allow the use of the %d in the config file for a wild card of sort to
@@ -402,7 +398,7 @@
 		}
 	}
 
-	if (gotsilence && truncate) {
+	if (gotsilence) {
 		ast_stream_rewind(s, silence - 1000);
 		ast_truncstream(s);
 	} else if (!gottimeout) {
obelix:~/asterisk-1.8.6.0# diff -u bkup-app_record.c apps/app_record.c
--- bkup-app_record.c	2011-09-19 11:46:41.000000000 +1000
+++ apps/app_record.c	2011-09-19 11:47:47.000000000 +1000
@@ -157,6 +157,7 @@
 	int gotsilence = 0;		/* did we timeout for silence? */
 	int maxduration = 0;		/* max duration of recording in milliseconds */
 	int gottimeout = 0;		/* did we timeout for maxduration exceeded? */
+	int truncate = 1;		/* truncate on complete silence recording */
 	int terminator = '#';
 	int rfmt = 0;
 	int ioflags;
@@ -219,6 +220,9 @@
 	if (ast_test_flag(&flags, OPTION_IGNORE_TERMINATE))
 		terminator = '\0';
 
+	if (ast_test_flag(&flags, OPTION_NO_TRUNCATE))
+		truncate = 0;
+
 	/* done parsing */
 
 	/* these are to allow the use of the %d in the config file for a wild card of sort to
@@ -398,7 +402,7 @@
 		}
 	}
 
-	if (gotsilence) {
+	if (gotsilence && truncate) {
 		ast_stream_rewind(s, silence - 1000);
 		ast_truncstream(s);
 	} else if (!gottimeout) {
